package zero1hd.polyjet.ui.windows;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.scenes.scene2d.Stage;
import com.badlogic.gdx.scenes.scene2d.ui.Skin;
import com.badlogic.gdx.scenes.scene2d.ui.TextField;
import com.badlogic.gdx.scenes.scene2d.ui.Window;

import zero1hd.polyjet.entity.Entities;
import zero1hd.polyjet.entity.Entity;
import zero1hd.polyjet.entity.EntityController;
import zero1hd.polyjet.entity.ally.Laser;
import zero1hd.polyjet.entity.enemies.VoidCircle;

public class SpawnerWindow extends Window {
	private TextField spawnName;
	private TextField modifier;
	private EntityController ec;
	private Stage stage;
	
	public SpawnerWindow(String title, Skin skin, EntityController ec, Stage stageForEntities) {
		super(title, skin);
		spawnName = new TextField("", skin);
		modifier = new TextField("0;0;0", skin);
		this.ec = ec;
		stage = stageForEntities;
	}
	
	
	@Override
	public boolean remove() {
		spawnName.setText("");
		return super.remove();
	}
	
	@Override
	public void act(float delta) {
		if (Gdx.input.isTouched() && !spawnName.getText().isEmpty()) {
			Entity entity = ec.retrieveEntity(Entities.valueOf(spawnName.getText()));
			switch(entity.getEntityType()) {
			case BAR_BEAT:
				break;
			case LASER:
				Laser laser = (Laser) entity;
				laser.init(Gdx.input.getX(), Gdx.input.getY(), Float.valueOf(modifier.getText().split(";")[0]));
				stage.addActor(laser);
				break;
			case SHARDS:
				break;
			case VOID_CIRCLE:
				VoidCircle voidCircle = (VoidCircle) entity;
				voidCircle.init(Float.valueOf(modifier.getText().split(";")[0]), Gdx.input.getX(), Gdx.input.getY(), Float.valueOf(modifier.getText().split(";")[1]), Float.valueOf(modifier.getText().split(";")[2]));
				stage.addActor(voidCircle);
				break;
			default:
				break;
			
			}
		}
		super.act(delta);
	}
}
